/*
    Make an OSC message and send it over UDP
    
    Adrian Freed
 */
#include <Ethernet.h>
#include <EthernetUdp.h>
#include <SPI.h>    
#include <OSCMessage.h>

EthernetUDP Udp;

//the Arduino's IP
IPAddress ip(192, 168, 0, 90);
//destination IP
IPAddress outIp(192, 168, 0, 99);
const unsigned int outPort = 53000;

byte mac[] = {  
  0xDF, 0x3B, 0x9C, 0xCF, 0x93, 0xA7 }; // you can find this written on the board of some Arduino Ethernets or shields

long count = 0;
  
void setup() {
  Serial.begin(9600);
  Ethernet.begin(mac,ip);
  Serial.println("Ethernet.begin() done");
  Udp.begin(8888);
  Serial.println("Udp.begin() done");
}


void loop(){
  //the message wants an OSC address as first argument
  OSCMessage msg("/cue/2/start");
  msg.add((int32_t) ++count);
  
  Udp.beginPacket(outIp, outPort);
  msg.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  msg.empty(); // free space occupied by message
  Serial.print("message ");
  Serial.print(count);
  Serial.println(" sent");

  delay(5000);
}
